<ng-container *ngIf="{
        ghostElements: ghostElements$ | async,
        categoryPage: dataPage$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.category.list.seo.title' | translate }}
      </h1>
      <p>
        {{ 'admin.category.list.seo.description' | translate }}
      </p>

      <section>
        <div class="table-wrapper">
          <table mat-table [dataSource]="loading.list ? vm.ghostElements : vm.categoryPage?.items"
                 [trackBy]="trackBySlug"
                 matSort matSortDisableClear
                 (matSortChange)="sort($event)"
                 [matSortActive]="vm.categoryPage?.sort?.field || 'name'"
                 [matSortDirection]="vm.categoryPage?.sort?.direction || 'asc'">

            <ng-container matColumnDef="name">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>
                {{ 'admin.category.list.field.name' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                {{ element.name | categoryLabel }}
              </td>
            </ng-container>

            <ng-container matColumnDef="playerCategories">
              <th mat-header-cell *matHeaderCellDef>
                {{ 'admin.category.list.field.playerCategories' | translate }}
              </th>
              <td mat-cell *matCellDef="let element">
                <mat-chip-list>
                  <ng-container *ngFor="let allowedCategory of element.rules.playerCategories | keyvalue; trackBy: trackByKey">
                    <mat-chip *ngIf="allowedCategory.value"
                              [color]="allowedCategory.value > -1 ? 'accent' : 'primary'" selected
                              [matTooltip]="allowedCategory.value > -1 ? ('admin.category.list.tip.limit' | translate:{ count: allowedCategory.value }) : ('admin.category.list.tip.noLimit' | translate)">
                      {{ allowedCategory.key | categoryLabel }}
                    </mat-chip>
                  </ng-container>
                </mat-chip-list>
              </td>
            </ng-container>

            <ng-container matColumnDef="action">
              <th mat-header-cell *matHeaderCellDef></th>
              <td mat-cell *matCellDef="let element"
                  class="actions">
                <a mat-icon-button
                   [routerLink]="[element.slug, 'update']"
                   [attr.aria-label]="'admin.common.action.update' | translate"
                   [matTooltip]="'admin.common.action.update' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    edit
                  </mat-icon>
                </a>
                <a mat-icon-button
                   [routerLink]="[element.slug, 'duplicate']"
                   [attr.aria-label]="'admin.common.action.duplicate' | translate"
                   [matTooltip]="'admin.common.action.duplicate' | translate"
                   matTooltipPosition="left">
                  <mat-icon>
                    filter_none
                  </mat-icon>
                </a>
                <button mat-icon-button
                        (click)="delete(element)"
                        [attr.aria-label]="'admin.common.action.delete' | translate"
                        [matTooltip]="'admin.common.action.delete' | translate"
                        matTooltipPosition="left">
                  <mat-icon>
                    delete
                  </mat-icon>
                </button>
              </td>
            </ng-container>

            <ng-container *ngFor="let ghostColumn of ghostColumns">
              <ng-container [matColumnDef]="ghostColumn">
                <td mat-cell *matCellDef class="ghost"><div></div></td>
              </ng-container>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="columns; sticky: true"></tr>
            <ng-container *ngIf="loading.list then ghost; else data"></ng-container>
            <ng-template #data>
              <tr mat-row *matRowDef="let row; columns: columns;"></tr>
            </ng-template>
            <ng-template #ghost>
              <tr mat-row *matRowDef="let row; columns: ghostColumns;"></tr>
            </ng-template>
          </table>
        </div>
        <mat-paginator [length]="vm.categoryPage?.count"
                       [pageIndex]="vm.categoryPage?.page"
                       [pageSize]="vm.categoryPage?.size"
                       [pageSizeOptions]="pageSizes"
                       (page)="goToPage($event)">
        </mat-paginator>
      </section>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-flat-button color="primary"
         [routerLink]="['create']">
        <mat-icon>
          add
        </mat-icon>
        {{ 'admin.common.action.create' | translate }}
      </a>
    </ng-container>
  </app-page-form>
</ng-container>
